// compare.cpp --> compare two gps and return 1 if same, 0 if not

/* Genetic Programming System using the C++ programming language

 Input is of the form gp <pop> <gen> <output file>

 A Potted History:

	 Version 1.00 BETA (sometime March 1993). Very Buggy,...
	 Version 2.00 C++ version very easy language 16 July 1993
								ERRORS in load and saving a genetic program.
											 No capacity for extended memory in DOS.
											 No differing creation mechanism.
											 No touranment selection
											 No capacity for encapsulation
	 Version 3.00 C++ Version.( Uncompatible with previous versions )
											 Robust with full use of OOP techniques.
											 Compatibility with ANSI standard.
											 Ramped half and half implemented.
											 Tournament selection implemented.
											 Changing variables does not require recompiling.
											 BUT STILL
											 No capacity for expanded or extended memory in DOS.
											 No capacity for encapsulation.

	 C version in progress
	 Windows version in progress but its all gobblydegook.


	 Version 3.00 can be compiled in the DOS and UNIX domain
	 but NOT in Windows. This was not made clear in previous programs.

 Genetic programming in C++ was designed and choreographed by Adam P.Fraser

		Food parcels, cash and trashy sci-fi novels to:

					 a.fraser@eee.salford.ac.uk
					snail:
					 A.Fraser
					 PostGraduate Section,
					 Maxwell Building,
					 Elec & Elec Eng,
					 University Of Salford,
					 Salford,
					 M5 4WT.
					 England


		Your comments, improvements and complaints are welcome.


 This code is intended as a base for C++ GPers. Please if you adapt the code
 send me a msg. Also could you please keeps these comments and my address in
 the code.

							regards,
											Adam Fraser ;-)
											16 November 1993

	' and one day there shall come an artificial ant who can complete the santa
	fe trail in 400 evaluation steps and on that day there shall be oink flap'
*/

#include "pop.hpp"

// compares gp input with every gp in the population return a 1 when the first
// identical gp is found else returns a 0;

int Population::Compare( GP *pgp )
{
	GP *pgpThis = this;

	while ( pgpThis != pgp )
	{
		if ( pgpThis->Compare( pgp ) != 0 ) return 1;
		pgpThis = pgpThis->pgpNext;
	}
	return 0;
}



int GP::Compare( GP *pgp )
{
	if ( this )
// presume that the genetic program is the same by sending a 1
	{
		if ( iLength != pgp->iLength ) return 0;
		else if ( pgHeader ) return pgHeader->Compare( pgp->pgHeader, 1 );
	}
	return 0; // will never reach here
}

int Gene::Compare( Gene *pg, int same )
{

	if ( same == 0 ) return 0;

	if ( iValue != pg->iValue )  return 0;

	if ( pgChild )
	{
		if ( pg->pgChild ) same = ( pgChild->Compare( pg->pgChild, same ) );
		else               return 0;
	}
	else
		if ( pg->pgChild ) return 0;


	if ( pgNext )
	{
		if ( pg->pgNext )  same = ( pgNext->Compare( pg->pgNext, same ) );
		else               return 0;
	}
	else
		if ( pg->pgNext )  return 0;


	return same;
}